"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorEncodings = exports.createErrorEncoding = void 0;
const utils_1 = require("../utils");
const basic_1 = require("./basic");
const errorProperties = ["stack", "name", "message"];
const nonEnumerableProperties = ["stack", "name"];
function createErrorEncoding(errorCtor) {
    return {
        prototypes: [errorCtor.prototype],
        key: (0, utils_1.getLibraryString)(errorCtor.name),
        encode(input, ctx) {
            const encodedAsObject = (0, basic_1.encodeObject)(input, ctx, false, errorProperties);
            ctx._isImplicit = false;
            return encodedAsObject;
        },
        decoder: {
            create(encodedValue, ctx) {
                return new errorCtor();
            },
            init(target, encoded, ctx) {
                (0, basic_1.decodeObject)(target, encoded, ctx);
            }
        }
    };
}
exports.createErrorEncoding = createErrorEncoding;
exports.errorEncodings = [
    Error,
    EvalError,
    RangeError,
    ReferenceError,
    TypeError,
    URIError,
    SyntaxError
].map(createErrorEncoding);

//# sourceMappingURL=built-in.js.map