"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetEncoding = exports.MapEncoding = void 0;
const utils_1 = require("../utils");
exports.MapEncoding = {
    prototypes: [Map.prototype],
    key: (0, utils_1.getLibraryString)("Map"),
    encode(input, ctx) {
        const array = [];
        for (const key of input.keys()) {
            const value = input.get(key);
            array.push([ctx.encode(key), ctx.encode(value)]);
        }
        return array;
    },
    decoder: {
        create(encodedValue, ctx) {
            return new Map();
        },
        init(target, encoded, ctx) {
            for (const [key, value] of encoded) {
                target.set(ctx.decode(key), ctx.decode(value));
            }
        }
    }
};
exports.SetEncoding = {
    prototypes: [Set.prototype],
    key: (0, utils_1.getLibraryString)("Set"),
    encode(input, ctx) {
        const outArray = [];
        for (const item of input) {
            outArray.push(ctx.encode(item));
        }
        return outArray;
    },
    decoder: {
        create() {
            return new Set();
        },
        init(target, encoded, ctx) {
            for (const item of encoded) {
                target.add(ctx.decode(item));
            }
        }
    }
};

//# sourceMappingURL=collections.js.map