export declare type Version = string;
export interface SzrEncodingSpec {
    [key: number]: number;
}
export declare type SzrEncodedEntity = SzrPrimitive | string | SzrDataObject | SzrEncodedEntity[];
export interface SzrDataObject {
    [key: string]: SzrEncodedEntity;
    [key: number]: SzrEncodedEntity;
}
export interface SzrMetadata {
    [key: number]: SzrEncodedEntity;
}
export declare type SzrEncodingKeys = string[];
export declare type SzrHeader = [Version, SzrEncodingKeys, SzrEncodingSpec, SzrMetadata];
export declare type Reference = string;
export declare type SzrEntity = string | object | any[] | symbol | Function;
export declare type SzrPrimitive = boolean | number | null;
export declare type SzrEncodedScalar = string;
export declare type SzrLeaf = SzrPrimitive | Reference | SzrEncodedScalar;
export declare type SzrFormat = [SzrHeader, ...SzrEncodedEntity[]];
export declare type SzrOutput = SzrFormat | SzrPrimitive | SzrEncodedScalar;
export declare const undefinedEncoding = "-";
export declare const infinityEncoding = "Infinity";
export declare const negInfinityEncoding = "-Infinity";
export declare const negZeroEncoding = "-0";
export declare const nanEncoding = "NaN";
export declare const noResultPlaceholder = "";
export declare function tryEncodeScalar(num: any): SzrEncodedScalar | SzrPrimitive;
export declare function tryDecodeScalar(candidate: any): any;
export declare const unrecognizedSymbolKey: string;
