import { DeepPartial, SzrConfig, SzrEncodingSpecifier } from "./szr-interface";
import { SzrOutput } from "./szr-representation";
/**
 * The class used to encode and decode things in the szr format.
 */
export declare class Szr {
    private _config;
    private _keyToEncoding;
    private _symbToEncoding;
    private _tempSymbEncoding;
    private _protoEncodingCache;
    private _protoEncodings;
    constructor(config?: DeepPartial<SzrConfig>);
    private _buildEncodingCache;
    addEncoding(...encoders: SzrEncodingSpecifier[]): void;
    private _findEncodingForObject;
    private _findEncodingForSymbol;
    private _findEncodingByKeyValue;
    private _checkInputValid;
    decode(input: SzrOutput): any;
    encode(root: any): SzrOutput;
}
export declare const defaultConfig: SzrConfig;
