"use strict";
// @ts-ignore
Object.defineProperty(exports, "__esModule", { value: true });
exports.version = exports.getUnrecognizedSymbol = exports.getUnrecognizedSymbolName = exports.getSymbolName = exports.getClassName = exports.getImplicitClassEncodingName = exports.getImplicitSymbolEncodingName = exports.getLibraryString = exports.defaultsDeep = exports._defaultsDeep = void 0;
let pkgJson;
try {
    pkgJson = require("../../../package.json");
}
catch (err) {
    pkgJson = require("./package.json");
}
function _defaultsDeep(target, source) {
    target = Object(target);
    if (!source)
        return target;
    source = Object(source);
    for (const [key, value] of Object.entries(source)) {
        if (typeof target[key] === "object") {
            defaultsDeep(target[key], Object(value));
        }
        else {
            if (target[key] === undefined) {
                target[key] = value;
            }
        }
    }
    return target;
}
exports._defaultsDeep = _defaultsDeep;
function defaultsDeep(target, ...sources) {
    for (const source of sources) {
        target = _defaultsDeep(target, source);
    }
    return target;
}
exports.defaultsDeep = defaultsDeep;
function getLibraryString(str) {
    return `!@#szr-${str}`;
}
exports.getLibraryString = getLibraryString;
function getImplicitSymbolEncodingName(str) {
    return getLibraryString(`symbol-${str}`);
}
exports.getImplicitSymbolEncodingName = getImplicitSymbolEncodingName;
function getImplicitClassEncodingName(str) {
    return getLibraryString(`class-${str}`);
}
exports.getImplicitClassEncodingName = getImplicitClassEncodingName;
function getClassName(proto) {
    var _a, _b;
    return (_a = proto[Symbol.toStringTag]) !== null && _a !== void 0 ? _a : (_b = proto.constructor) === null || _b === void 0 ? void 0 : _b.name;
}
exports.getClassName = getClassName;
function getSymbolName(symb) {
    return symb.toString().slice(7, -1);
}
exports.getSymbolName = getSymbolName;
function getUnrecognizedSymbolName(name) {
    return `szr unknown: ${name}`;
}
exports.getUnrecognizedSymbolName = getUnrecognizedSymbolName;
function getUnrecognizedSymbol(name) {
    return Symbol(getUnrecognizedSymbolName(name));
}
exports.getUnrecognizedSymbol = getUnrecognizedSymbol;
exports.version = pkgJson.version.split(".")[0];

//# sourceMappingURL=utils.js.map